% Grade calculator, TAM 203, Spring 2006
%Updated May 29, 2006

%This program roughly implements the following policy from the
%course WWW page:

% Final grade: After rescaling the 3 problems from prelim 1 to a common
% median, and the 3 problems from prelim 2 to a slightly higher common
% median, the lowest score from the 6 prelim questions will be dropped.
% Together the best 5 prelim question scores count for about 40% of your
% grade. The final homeworks count slightly more than the earlier
% homeworks. After dropping the lowest two homeork grades the homework
% will count as about 10% of your grade. The final exam counts about 35%,
% and the labs about 15%. TAs can add a few points for good section,
% office hour, or bonus project performance. One bonus point (1%) for
% completing a course evaluation form. The median student will get a B or
% B+ depending on overall class performance.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% The m-file rawscores has the course excel grade file cut and
% and pasted into it.  The first 7 students are fake perfect
% students who did a perfect job various different ways (bonus
% questions, makeup prelims, etc).  The array grades includes 
% all the numerical
% scores of all students.   The array names is a text file
% of students names.

 [grades names] =rawscores;  %enter the data

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%PICK OUT THE PARTS
%Becase the array grades has all grades it is easiest to
%pull out into separate arrays the different scores.

%PRELIMS
%questions 1-6, 3 questions from each of the two prelims
%The first 7 columns are the scores on the two prelims.
%Column 3 shows the scores of students who redid problem 2.
 prelim = grades(:,[1 2 4 5 6 7]);

%redo of question 2 on prelim 1
 redo2= grades(:,3);

%Average of first score on prelim1 question 2 and the redo.  Or just use the
%first score whichever is better
%Note the use of transpose ().  This is becase operations like
% max, mean and sort act on columns in Matlab and our data has
% students listed in rows.  Thus we transpose the data, take (e.g.)
%the max, and then transpose back.
 prelim(:,2) = max([prelim(:,2) (redo2 + prelim(:,2))/2]')';

%Makeup prelim (5 questions total). Students were told to do any
%4. But all 5 grades were recorded, one for each problem.
 makeup = grades(:,8:12) * (5/6);


%Put together all prelim grades, including makeup, 11 probs total
 prelim = [prelim makeup];

%Pick out the best 5 prelim scores, then average
%Note the use of transpose (') because the matlab function SORT works on
%columns and each student is a row in the spreadsheet.
 sortedprelim = flipud(sort(prelim')); % flip up-down sorts from best to worst
 bestprelim=sortedprelim(1:5,:);       % best 5 prelim scores, transposed ()

% Total prelim score: best possible is 26.6, best student turns out to be 25.4.
     prelimtotal=mean(bestprelim)'; % traspose back so a student is a row
% Scale out of 100
%  Best student turns out to be 101.6, close enought to 100
     prelimtotal = 4 * prelimtotal;

%%%%%%%%%%%%%%%%
%FINAL EXAM: best possible is 125,  best student turns out to have 107.
%There was an early final, a regular final, and (for students who took the makeup
% prelim (a makeup final). So two of the columns 13-15 are zero for each student.
% Note again the use of transpose () so that the max function works properly.
  finalexam = max([grades(:,13) grades(:,14) grades(:,15)]' )';

%%%%%%%%%%%
%HOMEWORK
hwbonus = grades(:,16:20);  % the five bonus problems
hw      = grades(:,27:54);  % the 28 regular homework assignments
hw      = [hw hwbonus];  % catenate homework and bonus probs

% Deal with late homeworks.  On the spreadsheet a late homework is
% indicated with a minus sign
 numlatehw = sum([hw<0]')'; % number of late homeworks
 hwlatepenalty =      ...  % No deduction for first 3 late homeworks
    1*(numlatehw==4)+ ...  % 1 point off for 4th late HW
    3*(numlatehw==5)+ ...  % 2 point off for 5th late HW
    6*(numlatehw==6)+ ...  % 3 point off for 6th late HW
   10*(numlatehw==7)+ ...  % 4 point off for 4th late HW
   (10 + 5 * (numlatehw - 7)).*(numlatehw>7) ; % 5 points for each additional

%Pick out the best 26 homework scores
 hw = abs(hw); % get rid of the minus sign used to indicate "late"
 sortedhw = flipud(sort(hw'));  % sort from best to worst
 besthw=sortedhw(1:26,:);       % best 26 homework scores

%Calculate total homework score.  Best possible is 10.
  hwtotal=(sum(besthw) - hwlatepenalty')'/26;  % transpose to get back into a column
%Scale homework out of 100
  hwtotal = 10 * hwtotal;

%LABS, 4 labs with up to 15 points each
  labs = mean(grades(:,21:24)')';

%Statics Exam (1 pt credit if student did online exam)
   statics = grades(:, 25);  % grade should be 1 or zero.

%Course Evaluation (1 pt credit if student did online course evaluation)
   ceval=grades(:,26);     %Course evaluation, should be 1 or zero.

 
% Find number of students in class 
n=length(finalexam);   % (includes 7 dummies)




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Calculate the big number

 total_grade =  finalexam    *0.35 ...    % 35 percent of grade
              + prelimtotal * 0.40 ...    % 40 percent 
              + hwtotal * .10 ...         % 10 percent
			  + labs ...                  % 15 percent 
			  + statics ...               %  1 percent
			  + ceval ;                   %  1 percent
    
% DISTRIBUTION PLOT
% X axis is the total score
% Y axis is percent of students with that score or less
    x=sort(total_grade);
    plot(x,(1:n)*100/n);  

% LETTER GRADE CUTOFFS	
  cutoff=[   97  % A+
             88  % A
	  	     85  % A-
		         %
		     80  % B+
		     76  % B
		     73  % B-
		         %
		     70  % C+
		     67  % C
		     65  % C-
		         %
		     60  % D+
		     50  % D
		     48  % D-
		         %
	          0];% F

%ASSIGN LETTER GRADES	

% Make a  13 by 2 text array of the 13 possible letter grades		 				
  letter=reshape('A+A A-B+B B-C+C C-D+D D-F ',2, 13)';

% Initialize students letter_grade,   two spaces for each row
   letter_grade= setstr( 32* ones(n, 2));  

% Check to see what grade a student should get
   for j=1:n;    % once through for each student
     for i=13:-1:1;                %once through for each letter grade
       if ( total_grade(j)   >= cutoff(i) -.15  ); % a little generous to minimize whining
	        letter_grade(j,:) = letter(i,:)  ;
	   end;
     end;
   end;
		 
% Print to screen  total_grade number for each student, in spreadsheet order		 
   iorder=1:n;
   [total_grade(iorder,:) ]

space(1:n,1)=' '; format bank;  % Set up formatting for grade 

total_grade = .01*round(total_grade*100);  % rounding of total_grade

% Print to screen: names, total score and grades, from best to worst
   [y, iorder] = sort(total_grade);
   iorder=flipud(iorder);  % sort from best to worst
   [names(iorder,:) space letter_grade(iorder,:) space  num2str(total_grade(iorder))]
 
% Print to screen: names, total score and grades, alphbetical order
% Three printings, first is readable, 2nd two for pasting back into
% spreadsheet.
   [names space letter_grade space num2str(total_grade)]  % readable
   letter_grade     % letters only, for pasting into spreadsheet
   num2str(total_grade)  % numbers only, for pasting into spreadsheet

